Kerbal Space Program - Bug #2014

Problem with multiple science experiments with the same ID
01/03/2014 08:00 AM - tobyb121

Status: Closed Start date: 01/03/2014
Severity: Normal % Done: 100%
Assignee:

Category: Gameplay

Target version:

Version: 0.23 Language: English (US)
Platform: Any Mod Related: No
Expansion:

Description

Overview:

If multiple science experiments have the same experiment ID in science defs config files when they are loaded it causes an error and
stops any further experiments from being added.

Detail:

If there are experiments defined in an EXPERIMENT_DEFINITION node in a config file, when the first call is made to
ResearchAndDevelopment.GetExperimentIDs(), or any other call that generates the experiments list in ResearchAndDevelopment,
the following error is raised: ArgumentException: An element with the same key already exists in the dictionary.

This then causes the function to throw an exception and no further elements are added to the list. When any experiments are
performed this throws an error, as the experiment id does not exist.

Two EXPERIMENT_DEFINITIONs with the same ID could happed if a user tries to make a backup of their ScienceDefs.cfg file in
such a way that it is still loaded, by incorrectly installing mods or by two mods having the same ID.

History

#1 - 01/09/2014 12:49 AM - TruePikachu
- Status changed from New to Not a Bug
- % Done changed from 0 to 100

The two ways that you mentioned that this could happen technically both invalidate bug tracker status, in my eyes:

e Mods are not controlled by KSP, and as such, cannot have problems in them fixed by the KSP team
* The ScienceDefs.cfg file would not need to be backed up under normal circumstances, due to it not being written to by the game itself. The only
situation when it would have to be backed up is if one wishes to modify it, which constitutes a mod, see the first part.

#2 - 01/09/2014 08:21 AM - Ted
- Status changed from Not a Bug to New
- % Done changed from 100 to 0

Please don't close issues that you didn't create.

#3 - 07/17/2016 09:25 AM - TriggerAu

- Status changed from New to Needs Clarification

#4 - 08/08/2016 12:53 PM - TriggerAu
- Status changed from Needs Clarification to Closed

- % Done changed from 0 to 100

Closing this report out for now. If you find it is still occuring in the latest version of KSP please open a new report (and this one can be linked to it.) For
best results, the wiki contains really useful info for when creating a report http:/bugs.kerbalspaceprogram.com/projects/ksp/wiki.

You can also ask questions about the bug cleanup in the forum here:
http://forum.kerbalspaceprogram.com/index.php?/topic/143980-time-to-clean-up-the-bug-tracker/ and tag @TriggerAu to get my attention
